VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MapEmap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'------------------------------------------------------------------------------
'
'   ACTvZT[rX TvvO
'   e-map on netC^tF[XNX
'
'   Copyrights (c) 2004-2005 Advanced Core Technologies, Inc. All rights reserved.
'
'   2005/03/xx Rev.1.00 RIN J
'
'------------------------------------------------------------------------------

Option Explicit

'------------------------------------------------------------------------------
'   Constants
'------------------------------------------------------------------------------

'   [Private]

'   n}Ɋւ郂[h
Private Const MAP_CONTROL_POINTSELECT As Long = 0                                   '   H_I
Private Const MAP_CONTROL_MAPSCROLL As Long = 1                                     '   n}ړ
Private Const MAP_CONTROL_ZOOMIN As Long = 2                                        '   g
Private Const MAP_CONTROL_ZOOMOUT As Long = 3                                       '   k
'   n}̕\k
Private Const MAP_SCALE_DEFAULT As Long = 100000                                    '   ftHgl
'   n_`
'   -eLXg\-
'   ̍̃|Cg
Private Const TEXT_FONT_HEIGHT_SMALL As Long = 11                                   '   
Private Const TEXT_FONT_HEIGHT_LARGE As Long = 18                                   '   
'   ̍̍ŏ/ő|Cg
Private Const TEXT_FONT_HEIGHT_MIN As Long = 5                                      '   ŏ|Cg
Private Const TEXT_FONT_HEIGHT_MAX As Long = 50                                     '   ő|Cg
'   \ItZbg
Private Const TEXT_OFFSET_X As Long = 5                                             '   XW
Private Const TEXT_OFFSET_Y As Long = 5                                             '   YW
'   -ACR\-
'   ACRt@C̃pX
Private Const ICON_PATH As String = "\ImportImg\Point.ico"                          '   n_ACR
'   摜̃zbgX|bgʒu
Private Const ICON_HOTSPOT_X As Long = 15                                           '   XW
Private Const ICON_HOTSPOT_Y As Long = 15                                           '   YW
'   oH`
'   
Private Const LINE_WIDTH_DEFAULT As Long = 5                                        '   ftHgl
'   ̍ŏ/ő啝
Private Const LINE_WIDTH_MIN As Long = 1                                            '   ŏ
Private Const LINE_WIDTH_MAX As Long = 50                                           '   ő啝
'   ̎
Private Const LINE_STYLE_SOLID As Long = 0                                          '   
Private Const LINE_STYLE_DOT As Long = 1                                            '   _
Private Const LINE_STYLE_DASH  As Long = 2                                          '   j
Private Const LINE_STYLE_DOUBLE As Long = 3                                         '   d
'   |S`
'   
Private Const POLYGON_WIDTH_DEFAULT As Long = 5                                     '   ftHgl
'   ̍ŏ/ő啝
Private Const POLYGON_WIDTH_MIN As Long = 1                                         '   ŏ
Private Const POLYGON_WIDTH_MAX As Long = 50                                        '   ő啝
'   hԂ̎
Private Const POLYGON_BRUSH_NONE As Long = 0                                        '   hԂȂ
Private Const POLYGON_BRUSH_FILL As Long = 1                                        '   ʂɓhԂ
Private Const POLYGON_BRUSH_BDIAGONAL As Long = 2                                   '   45x̉Eΐnb`
Private Const POLYGON_BRUSH_CROSS As Long = 3                                       '   Åiqnb`
Private Const POLYGON_BRUSH_DIAGCROSS As Long = 4                                   '   45x̎΂ߊiqnb`
Private Const POLYGON_BRUSH_FDIAGONAL As Long = 5                                   '   45x̉Eオnb`
Private Const POLYGON_BRUSH_HORIZONTAL As Long = 6                                  '   nb`
Private Const POLYGON_BRUSH_VERTICAL As Long = 7                                    '   nb`
'   J[\pX(AvP[VtH_̑΃pX)
Private Const RESOURCE_PATH_CUR_MAPSCROLL As String = "\ImportImg\MapScroll.cur"    '   n}ړ
Private Const RESOURCE_PATH_CUR_ZOOMIN As String = "\ImportImg\ZoomIn.cur"          '   g
Private Const RESOURCE_PATH_CUR_ZOOMOUT As String = "\ImportImg\ZoomOut.cur"        '   k
'   e-map F؃T[o URL
Private Const EMAP_URL_AUTHSERVER As String = _
                "gis.e-map.co.jp/zdc_sdk_cgi/ninnsyou1/"                            '   OCT[o URL
Private Const EMAP_URL_ENVSERVER As String = _
                "gis.e-map.co.jp/zdc_sdk_cgi/update/"                               '   擾T[o URL
'   Œ胉x
Private Const AREA_START_POINT_STRING As String = "   START   "                     '   B /  ̃X^[gn_
'   oH`Ŏgpłőm[h
Private Const POINTS_COUNT_MAX As Long = 300000                                     '   ftHgl

'------------------------------------------------------------------------------
'   Members
'------------------------------------------------------------------------------

'   [Private]

Private m_ObjZDCMap As ZDCMap               '   n} ActiveX Rg[
Private m_ObjZDCCertify As ZDCCertify       '   F ActiveX Rg[
Private m_MapControl As Long                '   n}Ɋւ郂[h
Private m_FigIDCount As Long                '   ` ID 
Private m_PointLayerCount As Long           '   n_ Layer 
Private m_CalcLayer As Boolean              '   oH/|S`pC쐬tO
'   n_`
'   -eLXg\-
Private m_TextColor As Long                 '   A̐F
Private m_TextBackColor As Long             '   wiF
Private m_TextEdge As Boolean               '   
Private m_TextFill As Boolean               '   hԂ
Private m_TextX As Long                     '   ox(~bP)
Private m_TextY As Long                     '   ܓx(~bP)
Private m_TextLabel As String               '   \镶
Private m_TextOrigin As Boolean             '   \_
Private m_TextOffsetX As Long               '   \ItZbg()
Private m_TextOffsetY As Long               '   \ItZbg(c)
Private m_TextWidth As Long                 '   ʏ̕̕(sNZP)[擾̂]
Private m_TextHeight As Long                '   ʏ̍̕(sNZP)[擾̂]
Private m_TextType As String                '   `IuWFNg̎[擾̂]
Private m_TextFakeTransparent As Boolean    '   wi_ϓhԂ
Private m_TextBold As Boolean               '   w
Private m_TextFontHeight As Long            '   ̍̃|Cg
'   -ACR\-
Private m_IconPath As String                '   ACRt@C̃pX
Private m_IconX As Long                     '   Šox(~bP)
Private m_IconY As Long                     '   S̈ܓx(~bP)
Private m_IconHotSpotX As Long              '   摜̃zbgX|bgʒuXW
Private m_IconHotSpotY As Long              '   摜̃zbgX|bgʒuYW
Private m_IconComment As String             '   `Rg
Private m_IconType As String                '   `IuWFNg̎
'   oH`
Private m_LineColor As Long                 '   F
Private m_LineWidth As Long                 '   
Private m_LineType As String                '   `IuWFNg̎
Private m_LineStyle As Long                 '   ̎
'   |S`
Private m_PolygonBrushColor As Long         '   hԂ̐F
Private m_PolygonEdgeColor As Long          '   ̐F
Private m_PolygonEdgeColorDonut As Long     '   ̐Fih[ic|Sj
Private m_PolygonWidth As Long              '   ̕
Private m_PolygonBrush As Long              '   hԂ̎
Private m_PolygonX As Long                  '   Šox
Private m_PolygonY As Long                  '   S̈ܓx
Private m_PolygonFixed As Boolean           '   |S̃^Cv
Private m_PolygonType As String             '   `IuWFNg̎
Private m_PolygonFakeTransparent As Boolean '   |S_ϓhԂ

'------------------------------------------------------------------------------
'   Methods
'------------------------------------------------------------------------------

'   [Public]

'   e-mapF؃T[oɃOC
'   p[^
'       lpszUserID      [IN][UID
'       lpszPassword    [IN]pX[h
'   ߂l
'       True    OC
'       False   OCs
'   l
'       F،ʂ́A MainForm ̔F؃Rg[ ZDCCertify ̃Cxgnh ZDCCertify_LoginResult
'       ɕԂ܂B
Public Function LoginEmapServer(ByVal lpszUserID As String, ByVal lpszPassword As String) As Boolean
    LoginEmapServer = False '   ߂l̏
    
    '   O`FbNs
    If CheckEmapException() = True Then
        Exit Function
    End If
    
    '   OAEgԂH
    If m_ObjZDCCertify.CheckLogin() <> 0 Then
        '   OCɐH
        If m_ObjZDCCertify.Login( _
            lpszUserID, "", "", lpszPassword, "", _
            0, 1, 0, _
            EMAP_URL_AUTHSERVER, EMAP_URL_ENVSERVER) = 0 Then
            LoginEmapServer = True  '   OCɐݒ
        End If
    End If
End Function

'   e-mapF؃T[o烍OAEg
'   p[^
'       Ȃ
'   ߂l
'       True    OAEg
'       False   OAEgs
Public Function LogoutEmapServer() As Boolean
    LogoutEmapServer = False '   ߂l̏

    '   O`FbNs
    If CheckEmapException() = True Then
        Exit Function
    End If
    
    '   OCԂH
    If m_ObjZDCCertify.CheckLogin() = 0 Then
        '   OAEgłH
        If m_ObjZDCCertify.Logout() = 0 Then
            LogoutEmapServer = True  '   OAEgɐݒ
        Else
            MsgBox "OAEgɎs܂B", _
                vbOKOnly + vbCritical, _
                "G["
        End If
    End If
End Function

'   C^[tFCX̏
'   p[^
'       axZDCMap        [IN]n} ActiveX Rg[̃CX^X
'       axZDCCertify    [IN]F ActiveX Rg[̃CX^X
'   ߂l
'       Ȃ
Public Sub Initialize(ByVal axZDCMap As ZDCMap, ByVal axZDCCertify As ZDCCertify)
    '   ݒ
    Set m_ObjZDCMap = axZDCMap          '   n} ActiveX Rg[
    Set m_ObjZDCCertify = axZDCCertify  '   F ActiveX Rg[
    
    CheckEmapException                  '   O`FbNs
    
    m_CalcLayer = False '   oH/|S`pC쐬tȌ
    
    '   ĕ`
    m_ObjZDCMap.AutoUpdate = True           '   
    '   n}Ɋւ郂[h
    MapControl = MAP_CONTROL_POINTSELECT    '   H_I
    '   [n_`]
    '   A̐F
    TextColor = RGB(255, 0, 0)              '   ԐF
    '   wiF̐ݒ
    TextBackColor = RGB(255, 255, 0)        '   F
    '   
    TextEdge = False                        '   `Ȃ
    '   hԂ
    TextFill = True                         '   wiʂԂ
    '   ox(~bP)
    TextX = 0
    '   ܓx(~bP)
    TextY = 0
    '   \镶
    TextLabel = ""
    '   \_
    TextOrigin = True                       '   
    '   \ItZbg()
    TextOffsetX = TEXT_OFFSET_X             '   5|Cg
    '   \ItZbg(c)
    TextOffsetY = TEXT_OFFSET_Y             '   5|Cg
    '   ʏ̕̕(sNZP)
    m_TextWidth = 0
    '   ʏ̍̕(sNZP)
    m_TextHeight = 0
    '   `IuWFNg̎
    m_TextType = ""
    '   wi_ϓhԂ
    TextFakeTransparent = False             '   hԂȂ
    '   w
    TextBold = False                        '   ׎
    '   ̍̃|Cgl
    TextFontHeight = TEXT_FONT_HEIGHT_SMALL '   9|Cg
    '   ACRt@C̃pX
    IconPath = App.Path + ICON_PATH         '   n_ACR
    '   Šox(~bP)
    IconX = 0
    '   S̈ܓx(~bP)
    IconY = 0
    '   摜̃zbgX|bgʒuXW
    IconHotSpotX = ICON_HOTSPOT_X           '   15|Cg
    '   摜̃zbgX|bgʒuYW
    IconHotSpotY = ICON_HOTSPOT_Y           '   15|Cg
    '   `Rg
    IconComment = ""
    '   `IuWFNg̎
    m_IconType = ""
    '   [oH`]
    '   F
    LineColor = RGB(255, 0, 0)              '   ԐF
    '   
    LineWidth = LINE_WIDTH_DEFAULT          '   ftHgl 5
    '   `IuWFNg̎
    m_LineType = ""
    '   
    LineStyle = LINE_STYLE_SOLID            '   
    '   [|S`]
    '   hԂ̐F
    PolygonBrushColor = RGB(255, 255, 255)  '   F
    '   ̐F
    PolygonEdgeColor = RGB(0, 0, 255)       '   F
    '   
    PolygonWidth = POLYGON_WIDTH_DEFAULT    '   ftHgl 5
    '   hԂ̎
    PolygonBrush = POLYGON_BRUSH_NONE       '   hԂȂ
    '   Šox
    PolygonX = 0
    '   S̈ܓx
    PolygonY = 0
    '   |S̃^Cv
    PolygonFixed = False                    '   oܓxŒ
    '   `IuWFNg̎
    m_PolygonType = ""
    '   |S_ϓhԂ
    PolygonFakeTransparent = False          '   hԂȂ
End Sub

'   n}T[on}Rg[ɐݒ肷
'   p[^
'       Ȃ
'   ߂l
'       Ȃ
Public Sub SetEmapServerInfo()
    '   O`FbNs
    If CheckEmapException() = True Then
        Exit Sub
    End If

    '   n}Rg[
    m_ObjZDCMap.Init "", 0                                                  '   
    m_ObjZDCMap.SetMapServerInfo m_ObjZDCCertify.CID, m_ObjZDCCertify.SID   '   n}T[oݒ
    m_ObjZDCMap.SetAID m_ObjZDCCertify.AID                                  '   FIDݒ

    '   n}Rg[̃vpeB
    '   kڒl
    m_ObjZDCMap.MapScale = MAP_SCALE_DEFAULT    '   100000
    '   S}[N
    m_ObjZDCMap.CenterMark = 0                  '   \
    '   oܓxAXP[\
    m_ObjZDCMap.VisibleCenterPos = False        '   \
    '   o[XP[\
    m_ObjZDCMap.VisibleBarScale = True          '   \
End Sub

'   [gvZ / ŒZ[gvZ ̃P[VA|Cg\̔z`悷
'   p[^
'       Locs        [IN]P[V\̔z̐擪vf
'       nLocCount   [IN]P[V\̔z̗vf
'       Pnts        [IN]|Cg\̔z̐擪vf
'       nPntCount   [IN]|Cg\̔z̗vf
'   ߂l
'       True    P[VA|Cg\̔z̕`ɐ
'       False   P[VA|Cg\̔z̕`Ɏs
Friend Function DrawDistCalcRoute( _
                                    ByRef Locs() As Loc, ByVal nLocCount As Long, _
                                    ByRef Pnts() As Pnt, ByVal nPntCount As Long _
                                    ) As Boolean
    Dim lpszLabal As String     '   `悷郉x
    Dim nLon As Long            '   `悷ox
    Dim nLat As Long            '   `悷ܓx
    Dim Line As Variant         '   CIuWFNg
    Dim i As Long               '   JE^
    Dim nReturn As Long         '   ZDCSDK̖߂l

    DrawDistCalcRoute = False   '   ߂l̏
    
    '   O`FbNs
    If CheckEmapException() = True Then
        Exit Function
    End If
    
    '   ő|Cg𒴂ĂȂH
    If nPntCount > POINTS_COUNT_MAX Then
        Exit Function
    End If
    
    '   oH`pC͍쐬Ă邩H
    If m_CalcLayer = False Then
        nReturn = m_ObjZDCMap.CreateUserLayer("", 0)    '   oH`͍ŉʌŒ(0)̃Cw
        '   oH`pC̍쐬ɐH
        If nReturn <> 0 Then
            MsgBox "oH`pC̍쐬Ɏs܂B", vbOKOnly + vbCritical, "G["
            Exit Function
        End If
        m_CalcLayer = True '   쐬ςɐݒ
    End If
    
    nReturn = m_ObjZDCMap.CreateLine(Line)  '   CIuWFNg̍쐬
    '   CIuWFNg̍쐬ɐH
    If nReturn <> 0 Then
        MsgBox "CIuWFNg̍쐬Ɏs܂B", vbOKOnly + vbCritical, "G["
        Exit Function
    End If

    '   oH`̐ݒ
    Line.Color = LineColor  '   F
    Line.Width = LineWidth  '   
    Line.Style = LineStyle  '   ̎

    nReturn = m_ObjZDCMap.AddFigWithID(0, Line, CStr(m_FigIDCount)) '   [U`̓o^
    '   [U`̓o^ɐH
    If nReturn <> 0 Then
        MsgBox "oH`̃[U`̓o^Ɏs܂B", vbOKOnly + vbCritical, "G["
        Exit Function
    End If
    
    '   oH̕`̊Jn
    For i = 0 To nPntCount - 1
        nLon = CLng(CDbl(Pnts(i).szLon) * 3600000#) '   ox
        nLat = CLng(CDbl(Pnts(i).szLat) * 3600000#) '   ܓx
        Line.Add nLon, nLat '   _̒ǉ
    Next
    
    '   oH`̎擾
    m_LineType = Line.Type  '   `IuWFNg̎

    m_FigIDCount = m_FigIDCount + 1 '   ` ID CNg

    '   n_̕`̊Jn
    For i = 0 To nLocCount - 1
        '   u,v̂\邽߂Ɂu"vň͂(DrawPoint\bhlɂ̎dlL)
        lpszLabal = (i + 1) & "  " & Locs(i).nTime & "" + "  " + """" + Format(Locs(i).nDist, "###,##0") + """"
        DrawDistCalcRoute = DrawPoint(CDbl(Locs(i).szLon), CDbl(Locs(i).szLat), lpszLabal)
        '   n_̕`ɎsĂȂH
        If DrawDistCalcRoute = False Then
            MsgBox "P[V\̔z̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
            Exit Function
        End If
    Next
End Function

'   B / vZ ̃P[VA|Cg\̔z`悷
'   p[^
'       Locs        [IN]P[V\̔z̐擪vf
'       nLocCount   [IN]P[V\̔z̗vf
'       Pnts        [IN]|Cg\̔z̐擪vf
'       nPntCount   [IN]|Cg\̔z̗vf
'       Param       [IN]R}hp[^
'   ߂l
'       True    P[VA|Cg\̔z̕`ɐ
'       False   P[VA|Cg\̔z̕`ɐ
Friend Function DrawDistCalcArea( _
                                    ByRef Locs() As Loc, ByVal nLocCount As Long, _
                                    ByRef Pnts() As Pnt, ByVal nPntCount As Long, _
                                    ByRef Param As Param _
                                    ) As Boolean
    Dim lpszLabal As String     '   `悷郉x
    Dim nLon As Long            '   `悷ox
    Dim nLat As Long            '   `悷ܓx
    Dim Polygon As Variant      '   |SIuWFNg
    Dim i As Long               '   JE^
    Dim nReturn As Long         '   ZDCSDK̖߂l

    DrawDistCalcArea = False    '   ߂l̏

    '   O`FbNs
    If CheckEmapException() = True Then
        Exit Function
    End If

    '   ő|Cg𒴂ĂȂH
    If nPntCount > POINTS_COUNT_MAX Then
        Exit Function
    End If
    
    '   |S`pC͍쐬Ă邩H
    If m_CalcLayer = False Then
        nReturn = m_ObjZDCMap.CreateUserLayer("", 0)    '   |S`͍ŉʌŒ(0)̃Cw
        '   |S`pC̍쐬ɐH
        If nReturn <> 0 Then
            MsgBox "|S`pC̍쐬Ɏs܂B", vbOKOnly + vbCritical, "G["
            Exit Function
        End If
        m_CalcLayer = True '   쐬ςɐݒ
    End If
  
    nReturn = m_ObjZDCMap.CreatePolygon(Polygon)    '   |SIuWFNg̍쐬
    '   |SIuWFNg̍쐬ɐH
    If nReturn <> 0 Then
        MsgBox "|SIuWFNg̍쐬Ɏs܂B", vbOKOnly + vbCritical, "G["
        Exit Function
    End If

    '   |S`̐ݒ
    Polygon.BrushColor = PolygonBrushColor              '   hԂ̐F
    Polygon.EdgeColor = PolygonEdgeColor                '   ̐F
    Polygon.Width = PolygonWidth                        '   ̕
    Polygon.Brush = PolygonBrush                        '   hԂ̎
    Polygon.x = PolygonX                                '   Šox
    Polygon.y = PolygonY                                '   S̈ܓx
    Polygon.Fixed = PolygonFixed                        '   |S̃^Cv
    Polygon.FakeTransparent = PolygonFakeTransparent    '   |S_ϓhԂ

    nReturn = m_ObjZDCMap.AddFigWithID(0, Polygon, CStr(m_FigIDCount))  '   [U`̓o^
    '   [U`̓o^ɐH
    If nReturn <> 0 Then
        MsgBox "|S`̃[U`̓o^Ɏs܂B", vbOKOnly + vbCritical, "G["
        Exit Function
    End If

    '   |S̕`̊Jn
    For i = 0 To nPntCount - 1
        nLon = CLng(CDbl(Pnts(i).szLon) * 3600000#) '   ox
        nLat = CLng(CDbl(Pnts(i).szLat) * 3600000#) '   ܓx
        Polygon.Add nLon, nLat  '   _̒ǉ
    Next
    
    '   |S`̎擾
    m_PolygonType = Polygon.Type    '   `IuWFNg̎

    m_FigIDCount = m_FigIDCount + 1 '   ` ID CNg

    '   n_̕`̊Jn(P[Vꍇ)
    If nLocCount > 1 Then
        For i = 0 To nLocCount - 1
            '   u,v̂\邽߂Ɂu"vň͂(DrawPoint\bhlɂ̎dlL)
            lpszLabal = (i + 1) & "  " & Locs(i).nTime & "" + "  " + """" + Format(Locs(i).nDist, "###,##0") + """"
            DrawDistCalcArea = DrawPoint(CDbl(Locs(i).szLon), CDbl(Locs(i).szLat), lpszLabal)
            '   n_̕`ɎsĂȂH
            If DrawDistCalcArea = False Then
                MsgBox "P[V\̔z̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
                Exit Function
            End If
        Next
    End If

    '   n_̕`̊Jn(X^[gn_)
    lpszLabal = AREA_START_POINT_STRING
    DrawDistCalcArea = DrawPoint(CDbl(Param.szCalcArea_StartLon), CDbl(Param.szCalcArea_StartLat), lpszLabal)
    '   n_̕`ɎsĂȂH
    If DrawDistCalcArea = False Then
        MsgBox "X^[gn_̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
    End If
End Function

'   n}ɓH_\
'   p[^
'       Locs        [IN]P[V\̔z̐擪vf
'       nLocCount   [IN]P[V\̔z̗vf
'   ߂l
'       True    H_̕\ɐ
'       False   H_̕\Ɏs
Friend Function DrawLastLoc(ByRef Locs() As Loc, ByVal nLocCount As Long) As Boolean
    Dim nElement As Long    '   QƂvfԍ

    DrawLastLoc = False '   ߂l̏
   
    '   O`FbNs
    If CheckEmapException() = True Then
        Exit Function
    End If

    nElement = nLocCount - 1    '   Ō̗vfԍ̎擾

    '   n_̕`̊Jn(Ō̒n_)
    DrawLastLoc = DrawPoint(CDbl(Locs(nElement).szLon), CDbl(Locs(nElement).szLat), CStr(nElement + 1))
    '   n_̕`ɎsĂȂH
    If DrawLastLoc = False Then
        MsgBox "P[V\̂̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
    End If
End Function

'   n}̒S_ݒ肷
'   p[^
'       nLon    [IN]S_ɐݒ肷ox
'       nLat    [IN]S_ɐݒ肷ܓx
'   ߂l
'       Ȃ
Public Sub PanMap(ByVal nLon As Long, ByVal nLat As Long)
    Dim WindowXTo, WindowYTo As Variant     '   ړ
    Dim WindowXFrom, WindowYFrom As Variant '   ړ
    
    '   O`FbNs
    If CheckEmapException() = True Then
        Exit Sub
    End If
    
    '   n}W(oܓx)  EBhEW ɕϊ
    m_ObjZDCMap.CnvMapToWin nLon, nLat, WindowXTo, WindowYTo                                    '   ړ
    m_ObjZDCMap.CnvMapToWin m_ObjZDCMap.CenterX, m_ObjZDCMap.CenterY, WindowXFrom, WindowYFrom  '   ړ
    '   n}ړ    ɃXN[ , ɃXN[
    m_ObjZDCMap.ScrollMap WindowXTo - WindowXFrom, WindowYTo - WindowYFrom
End Sub

'   n}̃IuWFNgSč폜
'   p[^
'       Ȃ
'   ߂l
'       Ȃ
Public Sub ClearMap()
    Dim i As Long   '   JE^

    '   O`FbNs
    If CheckEmapException() = True Then
        Exit Sub
    End If

    '   [U`̍폜
    For i = 0 To m_FigIDCount - 1
        m_ObjZDCMap.DeleteFig CStr(i)   '   [U`폜
    Next
    m_FigIDCount = 0    '   `ID̃Zbg
    
    '   oH/|S`pC͍쐬Ă邩H
    If m_CalcLayer = True Then
        m_ObjZDCMap.ReleaseUserLayer 0  '   oH/|S`pC̍폜
        m_CalcLayer = False             '   
    End If

    '   쐬ς̒n_CSč폜
    For i = 1 To m_PointLayerCount
        m_ObjZDCMap.ReleaseUserLayer (i)  '   n_C̍폜
    Next
    m_PointLayerCount = 0   '   n_C̃Zbg
End Sub

'   n}EBhEړ
'   p[^
'       Left    [IN][̐̍W (x )
'       Top     [IN][̐̍W (y )
'       Width   [IN]
'       Height  [IN]
'   ߂l
'       Ȃ
Public Sub MoveMapWindow(ByVal Left As Single, ByVal Top As Single, ByVal Width As Single, ByVal Height As Single)
    '   O`FbNs
    If CheckEmapException() = True Then
        Exit Sub
    End If

    m_ObjZDCMap.Move Left, Top, Width, Height '   n}EBhËړ
End Sub

'   n}EBhEZI[_[ݒ肷
'   p[^
'       nPosition   [IN] 0 ōőOʂ 1 ōŔwʂɈړ
'   ߂l
'       Ȃ
'   l
'       [VB6萔]
'       vbBringToFront 0 őOʂɈړ
'       vbSendToBack   1 Ŕwʂֈړ
Public Sub SetZOrder(ByVal nPosition As Long)
    '   O`FbNs
    If CheckEmapException() = True Then
        Exit Sub
    End If

    m_ObjZDCMap.ZOrder nPosition  '   n}EBhEZI[_[̐ݒ
End Sub

'   n}Rg[̃J[\n}샂[hɑΉJ[\ɐݒ肷
'   p[^
'       nMapControl [IN]n}Ɋւ郂[h
'   ߂l
'       True    J[\ݒɐ
'       False   J[\ݒɎs
'   l
'       [n}Ɋւ郂[h萔]
'       H_I  MAP_CONTROL_POINTSELECT
'       n}ړ    MAP_CONTROL_SCROLL
'       g        MAP_CONTROL_ZOOMIN
'       k        MAP_CONTROL_ZOOMOUT
Public Function SetEmapCursor(ByVal nMapControl As Long) As Boolean
    SetEmapCursor = False   '   ߂l̏

    '   O`FbNs
    If CheckEmapException() = True Then
        Exit Function
    End If

    '   [hln}Rg[̃J[\̐ݒs
    Select Case nMapControl
        Case MAP_CONTROL_POINTSELECT    '   H_I
            If m_ObjZDCMap.ChangeCursor("", 0, 0) = 0 Then
                SetEmapCursor = True    '   J[\ύXɐ
            End If
        Case MAP_CONTROL_MAPSCROLL      '   n}ړ
            If m_ObjZDCMap.ChangeCursor(App.Path + RESOURCE_PATH_CUR_MAPSCROLL, 0, 0) = 0 Then
                SetEmapCursor = True    '   J[\ύXɐ
            End If
        Case MAP_CONTROL_ZOOMIN         '   g
            If m_ObjZDCMap.ChangeCursor(App.Path + RESOURCE_PATH_CUR_ZOOMIN, 0, 0) = 0 Then
                SetEmapCursor = True    '   J[\ύXɐ
            End If
        Case MAP_CONTROL_ZOOMOUT        '   k
            If m_ObjZDCMap.ChangeCursor(App.Path + RESOURCE_PATH_CUR_ZOOMOUT, 0, 0) = 0 Then
                SetEmapCursor = True    '   J[\ύXɐ
            End If
    End Select
End Function

'   [Private]

'   n}ɒn_`悷
'   p[^
'       ldX         [IN]`悷n_̌ox
'       ldY         [IN]`悷n_̈ܓx
'       lpszLabel   [IN]`悷郉x
'   ߂l
'       True    n_̕`ɐ
'       False   n_̕`Ɏs
'   l
'       e-mapeLXgIuWFNgTextvpeB́u,vgpƉsdlƂȂĂB
'       u,v̂TextvpeBɕ\ꍇ́A\eLXgu"vň͂ޕKvB
Private Function DrawPoint(ByVal ldX As Double, ByVal ldY As Double, ByVal lpszLabel As String) As Boolean
    Dim nLon As Long        '   ox
    Dim nLat As Long        '   ܓx
    Dim Text As Variant     '   eLXgIuWFNg
    Dim Icon As Variant     '   ACRIuWFNg
    Dim nReturn As Long     '   ZDCSDK̖߂l
    
    DrawPoint = False       '   ߂l̏

    '   n_C̍쐬
    nReturn = m_ObjZDCMap.CreateUserLayer("", m_PointLayerCount + 1)    '   n_` 1 ȏ̃Cw
    '   n_C̍쐬ɐH
    If nReturn <> 0 Then
        MsgBox "n_C̍쐬Ɏs܂B", vbOKOnly + vbCritical, "G["
        Exit Function
    End If

    m_PointLayerCount = m_PointLayerCount + 1   '   n_ Layer CNg

    '   ox/ܓxl̕ϊ
    nLon = CLng(ldX * 3600000#)     '   ox
    nLat = CLng(ldY * 3600000#)     '   ܓx
    
    nReturn = m_ObjZDCMap.CreateText(Text)  '   eLXgIuWFNg̍쐬
    '   eLXgIuWFNg̍쐬ɐH
    If nReturn <> 0 Then
        MsgBox "eLXgIuWFNg̍쐬Ɏs܂B", vbOKOnly + vbCritical, "G["
        Exit Function
    End If

    '   p[^vpeBɐݒ
    TextX = nLon                                '   ox(~bP)
    TextY = nLat                                '   ܓx(~bP)
    TextLabel = lpszLabel                       '   \镶
    
    '   n_`(eLXg\)̐ݒ
    Text.TextColor = TextColor                  '   A̐F
    Text.BackColor = TextBackColor              '   wiF
    Text.Edge = TextEdge                        '   
    Text.Fill = TextFill                        '   hԂ
    Text.x = TextX                              '   ox(~bP)
    Text.y = TextY                              '   ܓx(~bP)
    Text.Text = TextLabel                       '   \镶
    Text.Origin = TextOrigin                    '   \_
    Text.OffsetX = TextOffsetX                  '   \ItZbg()
    Text.OffsetY = TextOffsetY                  '   \ItZbg(c)
    Text.FakeTransparent = TextFakeTransparent  '   wi_ϓhԂ
    Text.Bold = TextBold                        '   w
    Text.FontHeight = TextFontHeight            '   ̍̃|Cgl
    
    nReturn = m_ObjZDCMap.AddFigWithID(m_PointLayerCount, Text, CStr(m_FigIDCount)) '   [U`̓o^
    '   eLXg\̃[U`̓o^ɐH
    If nReturn <> 0 Then
        MsgBox "eLXg\̃[U`̓o^Ɏs܂B", vbOKOnly + vbCritical, "G["
        Exit Function
    End If
    
    '   n_`(eLXg\)̎擾
    m_TextWidth = Text.Width    '   ʏ̕̕(sNZP)
    m_TextHeight = Text.Height  '   ʏ̍̕(sNZP)
    m_TextType = Text.Type      '   `IuWFNg̎
    
    m_FigIDCount = m_FigIDCount + 1 '   ` ID CNg

    nReturn = m_ObjZDCMap.CreateSpecifiedImgObject(Icon)    '   ACRIuWFNg̍쐬
    '   ACRIuWFNg̍쐬ɐH
    If nReturn <> 0 Then
        MsgBox "ACRIuWFNg̍쐬Ɏs܂B", vbOKOnly + vbCritical, "G["
        Exit Function
    End If

    '   p[^vpeBɐݒ
    IconX = nLon                    '   Šox
    IconY = nLat                    '   S̈ܓx

    '   n_`(ACR\)̐ݒ
    Icon.Path = IconPath            '   n_ACRt@C̃pX(AvP[VtH_̐΃pX)
    Icon.x = IconX                  '   Šox
    Icon.y = IconY                  '   S̈ܓx
    Icon.HotSpotX = IconHotSpotX    '   摜̃zbgX|bgʒuXW
    Icon.HotSpotY = IconHotSpotY    '   摜̃zbgX|bgʒuYW
    Icon.Comment = IconComment      '   `Rg

    nReturn = m_ObjZDCMap.AddFigWithID(m_PointLayerCount, Icon, CStr(m_FigIDCount)) '   [U`̓o^

    '   ACR\̃[U`̓o^ɐH
    If nReturn <> 0 Then
        MsgBox "ACR\̃[U`̓o^Ɏs܂B", vbOKOnly + vbCritical, "G["
        Exit Function
    End If
    
    '   n_`(ACR\)̎擾
    m_IconType = Icon.Type  '   `IuWFNg̎

    m_FigIDCount = m_FigIDCount + 1 '   ` ID CNg
    
    DrawPoint = True    '   쐬
End Function

'   O`FbNs
'   p[^
'       Ȃ
'   ߂l
'       True    '   O
'       False   '   O݂͑Ȃ
Private Function CheckEmapException() As Boolean
    Dim lpszExceptionMessage As String  '   ObZ[W
    
    CheckEmapException = False  '   ߂l̏
    lpszExceptionMessage = ""   '   ObZ[W̏
    
    '   n} ActiveX Rg[̃CX^Xݒ肳Ă邩H
    If m_ObjZDCMap Is Nothing Then
        lpszExceptionMessage = "n} ActiveX Rg[̃CX^Xݒ肳Ă܂B"
        CheckEmapException = True '   Oʒm
    End If
    '   F ActiveX Rg[̃CX^Xݒ肳Ă邩H
    If m_ObjZDCCertify Is Nothing Then
        If CheckEmapException = True Then
            lpszExceptionMessage = lpszExceptionMessage + vbCrLf    '   s
        End If
        lpszExceptionMessage = lpszExceptionMessage + "F ActiveX Rg[̃CX^Xݒ肳Ă܂B"
        CheckEmapException = True '   Oʒm
    End If

    '   ObZ[We̕\
    If CheckEmapException = True Then
        MsgBox lpszExceptionMessage, vbOKOnly + vbCritical, "O"
    End If
End Function

'------------------------------------------------------------------------------
'   Properties
'------------------------------------------------------------------------------

'   [Public]

'   n}Ɋւ郂[h擾/ݒ肷
'   擾
Public Property Get MapControl() As Long
    MapControl = m_MapControl
End Property
'   ݒ
Public Property Let MapControl(ByVal nMapControl As Long)
    '   [hln}Rg[̃J[\̐ݒs
    If SetEmapCursor(nMapControl) = False Then
        Exit Property
    End If
    m_MapControl = nMapControl  '   [hl̐ݒ
End Property

'   n}̎ނ擾/ݒ肷
'   擾
Public Property Get MapType() As Long
    '   O`FbNs
    If CheckEmapException() = True Then
        MapType = -1    '   e-mapŖgp̒l
        Exit Property
    End If
    MapType = m_ObjZDCMap.MapType
End Property
'   ݒ
Public Property Let MapType(ByVal nMapType As Long)
    '   O`FbNs
    If CheckEmapException() = True Then
        Exit Property
    End If
    m_ObjZDCMap.MapType = nMapType
End Property

'   n}̕\kڒl擾/ݒ肷
'   擾
Public Property Get MapScale() As Long
    '   O`FbNs
    If CheckEmapException() = True Then
        MapScale = -1    '   e-mapŖgp̒l
        Exit Property
    End If
    MapScale = m_ObjZDCMap.MapScale
End Property
'   ݒ
Public Property Let MapScale(ByVal nMapScale As Long)
    '   O`FbNs
    If CheckEmapException() = True Then
        Exit Property
    End If
    '   L͈͂̃`FbN
    If (nMapScale > m_ObjZDCMap.MinScale) And (nMapScale < m_ObjZDCMap.MaxScale) Then
        m_ObjZDCMap.MapScale = nMapScale
    End If
End Property

'   [n_`]

'   -eLXg\-

'   A̐F擾/ݒ肷
'   擾
Public Property Get TextColor() As Long
    TextColor = m_TextColor
End Property
'   ݒ
Public Property Let TextColor(ByVal nRGB As Long)
    '   RGB l͈͓̔H
    If (nRGB >= RGB(0, 0, 0)) And (nRGB <= RGB(255, 255, 255)) Then
        m_TextColor = nRGB
    End If
End Property

'   wiF擾/ݒ肷
'   擾
Public Property Get TextBackColor() As Long
    TextBackColor = m_TextBackColor
End Property
'   ݒ
Public Property Let TextBackColor(ByVal nRGB As Long)
    '   RGB l͈͓̔H
    If (nRGB >= RGB(0, 0, 0)) And (nRGB <= RGB(255, 255, 255)) Then
        m_TextBackColor = nRGB
    End If
End Property

'   擾/ݒ肷
'   擾
Public Property Get TextEdge() As Boolean
    TextEdge = m_TextEdge
End Property
'   ݒ
Public Property Let TextEdge(ByVal bTextEdge As Boolean)
    m_TextEdge = bTextEdge
End Property

'   hԂ擾/ݒ肷
'   擾
Public Property Get TextFill() As Boolean
    TextFill = m_TextFill
End Property
'   ݒ
Public Property Let TextFill(ByVal bTextFill As Boolean)
    m_TextFill = bTextFill
End Property

'   ox(~bP)擾/ݒ肷
'   擾
Public Property Get TextX() As Long
    TextX = m_TextX
End Property
'   ݒ
Public Property Let TextX(ByVal nTextX As Long)
    m_TextX = nTextX
End Property

'   ܓx(~bP)擾/ݒ肷
'   擾
Public Property Get TextY() As Long
    TextY = m_TextY
End Property
'   ݒ
Public Property Let TextY(ByVal nTextY As Long)
    m_TextY = nTextY
End Property

'   \镶擾/ݒ肷
'   擾
Public Property Get TextLabel() As String
    TextLabel = m_TextLabel
End Property
'   ݒ
Public Property Let TextLabel(ByVal lpszTextLabel As String)
    m_TextLabel = lpszTextLabel
End Property

'   \_擾/ݒ肷
'   擾
Public Property Get TextOrigin() As Boolean
    TextOrigin = m_TextOrigin
End Property
'   ݒ
Public Property Let TextOrigin(ByVal bTextOrigin As Boolean)
    m_TextOrigin = bTextOrigin
End Property

'   \ItZbg()擾/ݒ肷
'   擾
Public Property Get TextOffsetX() As Long
    TextOffsetX = m_TextOffsetX
End Property
'   ݒ
Public Property Let TextOffsetX(ByVal nTextOffsetX As Long)
    m_TextOffsetX = nTextOffsetX
End Property

'   \ItZbg(c)擾/ݒ肷
'   擾
Public Property Get TextOffsetY() As Long
    TextOffsetY = m_TextOffsetY
End Property
'   ݒ
Public Property Let TextOffsetY(ByVal nTextOffsetY As Long)
    m_TextOffsetY = nTextOffsetY
End Property

'   ʏ̕̕(sNZP)擾
'   擾
Public Property Get TextWidth() As Long
    TextWidth = m_TextWidth
End Property

'   ʏ̍̕(sNZP)擾
'   擾
Public Property Get TextHeight() As Long
    TextHeight = m_TextHeight
End Property

'   `IuWFNg̎ނ擾
'   擾
Public Property Get TextType() As String
    TextType = m_TextType
End Property

'   wi_ϓhԂ擾/ݒ肷
'   擾
Public Property Get TextFakeTransparent() As Boolean
    TextFakeTransparent = m_TextFakeTransparent
End Property
'   ݒ
Public Property Let TextFakeTransparent(ByVal bTextFakeTransparent As Boolean)
    m_TextFakeTransparent = bTextFakeTransparent
End Property

'   w擾/ݒ肷
'   擾
Public Property Get TextBold() As Boolean
    TextBold = m_TextBold
End Property
'   ݒ
Public Property Let TextBold(ByVal bTextBold As Boolean)
    m_TextBold = bTextBold
End Property

'   ̍(|CgP)擾/ݒ肷
'   擾
Public Property Get TextFontHeight() As Long
    TextFontHeight = m_TextFontHeight
End Property
'   ݒ
Public Property Let TextFontHeight(ByVal nTextFontHeight As Long)
    '   ̍̃|Cgl͈͓̔H
    If (nTextFontHeight >= TEXT_FONT_HEIGHT_MIN) And (nTextFontHeight <= TEXT_FONT_HEIGHT_MAX) Then
        m_TextFontHeight = nTextFontHeight
    End If
End Property

'   -ACR\-

'   ACRt@C̃pX擾/ݒ肷
'   擾
Public Property Get IconPath() As String
    IconPath = m_IconPath
End Property
'   ݒ
Public Property Let IconPath(ByVal lpszIconPath As String)
    m_IconPath = lpszIconPath
End Property

'   Šox(~bP)擾/ݒ肷
'   擾
Public Property Get IconX() As Long
    IconX = m_IconX
End Property
'   ݒ
Public Property Let IconX(ByVal nIconX As Long)
    m_IconX = nIconX
End Property

'   S̈ܓx(~bP)擾/ݒ肷
'   擾
Public Property Get IconY() As Long
    IconY = m_IconY
End Property
'   ݒ
Public Property Let IconY(ByVal nIconY As Long)
    m_IconY = nIconY
End Property

'   摜̃zbgX|bgʒuXW擾/ݒ肷
'   擾
Public Property Get IconHotSpotX() As Long
    IconHotSpotX = m_IconHotSpotX
End Property
'   ݒ
Public Property Let IconHotSpotX(ByVal nIconHotSpotX As Long)
    m_IconHotSpotX = nIconHotSpotX
End Property

'   摜̃zbgX|bgʒuYW擾/ݒ肷
'   擾
Public Property Get IconHotSpotY() As Long
    IconHotSpotY = m_IconHotSpotY
End Property
'   ݒ
Public Property Let IconHotSpotY(ByVal nIconHotSpotY As Long)
    m_IconHotSpotY = nIconHotSpotY
End Property

'   `Rg擾/ݒ肷
'   擾
Public Property Get IconComment() As String
    IconComment = m_IconComment
End Property
'   ݒ
Public Property Let IconComment(ByVal lpszIconComment As String)
    m_IconComment = lpszIconComment
End Property

'   `IuWFNg̎ނ擾
'   擾
Public Property Get IconType() As String
    IconType = m_IconType
End Property

'   [oH`]

'   F擾/ݒ肷
'   擾
Public Property Get LineColor() As Long
    LineColor = m_LineColor
End Property
'   ݒ
Public Property Let LineColor(ByVal nRGB As Long)
    '   RGBl͈͓̔H
    If (nRGB >= RGB(0, 0, 0)) And (nRGB <= RGB(255, 255, 255)) Then
        m_LineColor = nRGB
    End If
End Property

'   擾/ݒ肷
'   擾
Public Property Get LineWidth() As Long
    LineWidth = m_LineWidth
End Property
'   ݒ
Public Property Let LineWidth(ByVal nLineWidth As Long)
    '   RGBl͈͓̔H
    If (nLineWidth >= LINE_WIDTH_MIN) And (nLineWidth <= LINE_WIDTH_MAX) Then
        m_LineWidth = nLineWidth
    End If
End Property

'   `IuWFNg̎ނ擾
'   擾
Public Property Get LineType() As String
    LineType = m_LineType
End Property

'   ̎ނ擾/ݒ肷
'   擾
Public Property Get LineStyle() As Long
    LineStyle = m_LineStyle
End Property
'   ݒ
Public Property Let LineStyle(ByVal nLineStyle As Long)
    '   X^Cl͈͓̔H
    If (nLineStyle >= LINE_STYLE_SOLID) And (nLineStyle <= LINE_STYLE_DOUBLE) Then
        m_LineStyle = nLineStyle
    End If
End Property

'   [|S`]

'   hԂ̐F擾/ݒ肷
'   擾
Public Property Get PolygonBrushColor() As Long
    PolygonBrushColor = m_PolygonBrushColor
End Property
'   ݒ
Public Property Let PolygonBrushColor(ByVal nRGB As Long)
    '   RGB l͈͓̔H
    If (nRGB >= RGB(0, 0, 0)) And (nRGB <= RGB(255, 255, 255)) Then
        m_PolygonBrushColor = nRGB
    End If
End Property

'   ̐F擾/ݒ肷
'   擾
Public Property Get PolygonEdgeColor() As Long
    PolygonEdgeColor = m_PolygonEdgeColor
End Property
'   ݒ
Public Property Let PolygonEdgeColor(ByVal nRGB As Long)
    '   RGBl͈͓̔H
    If (nRGB >= RGB(0, 0, 0)) And (nRGB <= RGB(255, 255, 255)) Then
        m_PolygonEdgeColor = nRGB
    End If
End Property

'   ̐F擾/ݒ肷ih[ic|Sj
'   擾
Public Property Get PolygonEdgeColorDonut() As Long
    PolygonEdgeColorDonut = m_PolygonEdgeColorDonut
End Property
'   ݒ
Public Property Let PolygonEdgeColorDonut(ByVal nRGB As Long)
    '   RGBl͈͓̔H
    If (nRGB >= RGB(0, 0, 0)) And (nRGB <= RGB(255, 255, 255)) Then
        m_PolygonEdgeColorDonut = nRGB
    End If
End Property

'   ̕擾/ݒ肷
'   擾
Public Property Get PolygonWidth() As Long
    PolygonWidth = m_PolygonWidth
End Property
'   ݒ
Public Property Let PolygonWidth(ByVal nPolygonWidth As Long)
    If (nPolygonWidth >= POLYGON_WIDTH_MIN) And (nPolygonWidth <= POLYGON_WIDTH_MAX) Then
        m_PolygonWidth = nPolygonWidth
    End If
End Property

'   hԂ̎ނ擾/ݒ肷
'   擾
Public Property Get PolygonBrush() As Long
    PolygonBrush = m_PolygonBrush
End Property
'   ݒ
Public Property Let PolygonBrush(ByVal nPolygonBrush As Long)
    '   X^Cl͈͓̔H
    If (nPolygonBrush >= POLYGON_BRUSH_NONE) And (nPolygonBrush <= POLYGON_BRUSH_VERTICAL) Then
        m_PolygonBrush = nPolygonBrush
    End If
End Property

'   Šox擾/ݒ肷
'   擾
Public Property Get PolygonX() As Long
    PolygonX = m_PolygonX
End Property
'   ݒ
Public Property Let PolygonX(ByVal nPolygonX As Long)
    m_PolygonX = nPolygonX
End Property

'   S̈ܓx擾/ݒ肷
'   擾
Public Property Get PolygonY() As Long
    PolygonY = m_PolygonY
End Property
'   ݒ
Public Property Let PolygonY(ByVal nPolygonY As Long)
    m_PolygonY = nPolygonY
End Property

'   |S̃^Cv擾/ݒ肷
'   擾
Public Property Get PolygonFixed() As Boolean
    PolygonFixed = m_PolygonFixed
End Property
'   ݒ
Public Property Let PolygonFixed(ByVal bPolygonFixed As Boolean)
    m_PolygonFixed = bPolygonFixed
End Property

'   `IuWFNg̎ނ擾
'   擾
Public Property Get PolygonType() As String
    PolygonType = m_PolygonType
End Property

'   |S_ϓhԂ擾/ݒ肷
'   擾
Public Property Get PolygonFakeTransparent() As Boolean
    PolygonFakeTransparent = m_PolygonFakeTransparent
End Property
'   ݒ
Public Property Let PolygonFakeTransparent(ByVal bPolygonFakeTransparent As Boolean)
    m_PolygonFakeTransparent = bPolygonFakeTransparent
End Property

'   B / vZ ̃P[VA|Cg\̔z`悷(CalcArea Ver2) Rev.1.03
'   p[^
'       Pnts        [IN]|Cg\̔z̐擪vf
'       nPntCount   [IN]|Cg\̔z̗vf
'       CAParam     [IN]CalcAreaR}hp[^
'   ߂l
'       True    P[VA|Cg\̔z̕`ɐ
'       False   P[VA|Cg\̔z̕`ɐ
Friend Function DrawDistCalcAreaCA( _
                                    ByRef Pnts() As Pnt, ByVal nPntCount As Long, _
                                    ByRef CAParam As CAParam _
                                    ) As Boolean
    Dim lpszLabal As String     '   `悷郉x
    Dim nLon As Long            '   `悷ox
    Dim nLat As Long            '   `悷ܓx
    Dim polygonLon As Long            '   `悷ox
    Dim polygonLat As Long            '   `悷ܓx
    Dim Polygon As Variant      '   |SIuWFNg
    Dim i As Long               '   JE^
    Dim nReturn As Long         '   ZDCSDK̖߂l
    Dim DonutFlg As Long        '   h[ic|StO
    Dim polygonNum As Long

    DrawDistCalcAreaCA = False    '   ߂l̏

    '   O`FbNs
    If CheckEmapException() = True Then
        Exit Function
    End If

    '   ő|Cg𒴂ĂȂH
    If nPntCount > POINTS_COUNT_MAX Then
        Exit Function
    End If
    
    If nPntCount > 0 Then
        '   |S`pC͍쐬Ă邩H
        If m_CalcLayer = False Then
            nReturn = m_ObjZDCMap.CreateUserLayer("", 0)    '   |S`͍ŉʌŒ(0)̃Cw
            '   |S`pC̍쐬ɐH
            If nReturn <> 0 Then
                MsgBox "|S`pC̍쐬Ɏs܂B", vbOKOnly + vbCritical, "G["
                Exit Function
            End If
            m_CalcLayer = True '   쐬ςɐݒ
        End If
      
        ' h[ic|StO
        DonutFlg = 1
        polygonLon = 0
        polygonLat = 0
        For i = 0 To nPntCount - 1
            
            nLon = CLng(CDbl(Pnts(i).szLon) * 3600000#) '   ox
            nLat = CLng(CDbl(Pnts(i).szLat) * 3600000#) '   ܓx
            
'            If i = 0 Or (nLon = 0 And nLat = 0) Then
' 2010/03/01 Lon, Lat 0.000000Ή
            If i = 0 Or (CDbl(Pnts(i).szLon) = 0 And CDbl(Pnts(i).szLat) = 0) Then
            
                ' Lon, LatƂɂOꍇ͌ɖ߂
                If DonutFlg = 0 Then
                    DonutFlg = 1
                Else
                    DonutFlg = 0
                End If
                             
                m_FigIDCount = m_FigIDCount + 1 '   ` ID CNg
                
                ' 2010/03/01@_͕\Ȃ
                If i <> 0 And polygonNum <= 1 Then
                    Polygon.RemoveAll
                End If
                
                polygonNum = 0
                polygonLon = 0
                polygonLat = 0
                                
                nReturn = m_ObjZDCMap.CreatePolygon(Polygon)    '   |SIuWFNg̍쐬
                '   |SIuWFNg̍쐬ɐH
                If nReturn <> 0 Then
                    MsgBox "|SIuWFNg̍쐬Ɏs܂B", vbOKOnly + vbCritical, "G["
                    Exit Function
                End If
    
                '   |S`̐ݒ
                Polygon.BrushColor = PolygonBrushColor              '   hԂ̐F
                If DonutFlg = 0 Then
                    Polygon.EdgeColor = PolygonEdgeColor                '   ̐F
                Else
                    Polygon.EdgeColor = PolygonEdgeColorDonut                '   ̐F
                End If
                Polygon.Width = PolygonWidth                        '   ̕
                Polygon.Brush = PolygonBrush                        '   hԂ̎
                Polygon.x = PolygonX                                '   Šox
                Polygon.y = PolygonY                                '   S̈ܓx
                Polygon.Fixed = PolygonFixed                        '   |S̃^Cv
                Polygon.FakeTransparent = PolygonFakeTransparent    '   |S_ϓhԂ
            
                nReturn = m_ObjZDCMap.AddFigWithID(0, Polygon, CStr(m_FigIDCount))  '   [U`̓o^
                '   [U`̓o^ɐH
                If nReturn <> 0 Then
                    MsgBox "|S`̃[U`̓o^Ɏs܂B", vbOKOnly + vbCritical, "G["
                    Exit Function
                End If
                
            Else
                DonutFlg = 0
            End If
            
'            If nLon = 0 And nLat = 0 Then
            If CDbl(Pnts(i).szLon) = 0 And CDbl(Pnts(i).szLat) = 0 Or (polygonLon = nLon And polygonLat = nLat) Then
                'AddȂ
            Else
                '   |S̕`̊Jn
                Polygon.Add nLon, nLat  '   _̒ǉ
                polygonLon = nLon
                polygonLat = nLat
                polygonNum = polygonNum + 1
            End If
        Next
        
        '   |S`̎擾
        m_PolygonType = Polygon.Type    '   `IuWFNg̎
    
        m_FigIDCount = m_FigIDCount + 1 '   ` ID CNg
    End If
    
    '   n_̕`̊Jn(X^[gn_)
    lpszLabal = AREA_START_POINT_STRING
    DrawDistCalcAreaCA = DrawPoint(CDbl(CAParam.StartGeoPnt.szLon), CDbl(CAParam.StartGeoPnt.szLat), lpszLabal)
    '   n_̕`ɎsĂȂH
    If DrawDistCalcAreaCA = False Then
        MsgBox "X^[gn_̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
    End If
End Function

'   B / vZ ̃P[VA|Cg\̔z`悷(CalcOneWay) Rev.1.03
'   p[^
'       Locs        [IN]P[V\̔z̐擪vf
'       nLocCount   [IN]P[V\̔z̗vf
'       COWParam    [IN]CalcOneWayR}hp[^
'   ߂l
'       True    P[VA|Cg\̔z̕`ɐ
'       False   P[VA|Cg\̔z̕`ɐ
Friend Function DrawDistCalcAreaCOW( _
                                    ByRef Locs() As Loc, ByVal nLocCount As Long, _
                                    ByRef COWParam As COWParam _
                                    ) As Boolean
    Dim lpszLabal As String     '   `悷郉x
    Dim nLon As Long            '   `悷ox
    Dim nLat As Long            '   `悷ܓx
    Dim Polygon As Variant      '   |SIuWFNg
    Dim i As Long               '   JE^
    Dim nReturn As Long         '   ZDCSDK̖߂l

    DrawDistCalcAreaCOW = False    '   ߂l̏

    '   O`FbNs
    If CheckEmapException() = True Then
        Exit Function
    End If

    '   n_̕`̊Jn(P[Vꍇ)
    If nLocCount > 1 Then
        For i = 0 To nLocCount - 1
            '   u,v̂\邽߂Ɂu"vň͂(DrawPoint\bhlɂ̎dlL)
            lpszLabal = (i + 1) & "  " & Locs(i).nTime & "" + "  " + """" + Format(Locs(i).nDist, "###,##0") + """"
            DrawDistCalcAreaCOW = DrawPoint(CDbl(Locs(i).szLon), CDbl(Locs(i).szLat), lpszLabal)
            '   n_̕`ɎsĂȂH
            If DrawDistCalcAreaCOW = False Then
                MsgBox "P[V\̔z̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
                Exit Function
            End If
        Next
    End If

    '   n_̕`̊Jn(X^[gn_)
    lpszLabal = AREA_START_POINT_STRING
    DrawDistCalcAreaCOW = DrawPoint(CDbl(COWParam.StartGeoPnt.szLon), CDbl(COWParam.StartGeoPnt.szLat), lpszLabal)
    '   n_̕`ɎsĂȂH
    If DrawDistCalcAreaCOW = False Then
        MsgBox "X^[gn_̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
    End If
End Function

'   End of Source

Private Sub Class_Initialize()

End Sub

